#ifndef __B0A61BF94EC74190B4F10F7D26765E14_inc__
#define __B0A61BF94EC74190B4F10F7D26765E14_inc__

#ifndef __windows_inc__
#include "windows.inc"
#endif

class CXMLDispatch
{
	declare CXMLDispatch();
	declare virtual QueryInterface(REFIID *riid, void *ppvObject),HRESULT;
	declare virtual AddRef(),ULONG;
	declare virtual Release(),ULONG;
	declare virtual GetTypeInfoCount(UINT *pctinfo),HRESULT;
	declare virtual GetTypeInfo(UINT iTInfo, LCID lcid, ITypeInfo *ppTInfo),HRESULT;
	declare virtual GetIDsOfNames(REFIID *riid, LPOLESTR rgszNames[], UINT cNames, LCID lcid, DISPID *rgDispId),HRESULT;
	declare virtual Invoke(DISPID dispIdMember, REFIID *riid, LCID lcid, USHORT wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, UINT *puArgErr);
	int   m_callback;
	void *m_param;
}


class XML
{
	declare XML();
	declare _XML();
	//
	// initialization
	//
	declare Open(LPWSTR path,opt BOOL fAsync=FALSE,opt BOOL externals=FALSE),BOOL;
	declare InitNew(),BOOL;
	declare AttachNode(IXMLDOMNode *node),BOOL;

	declare Save(LPWSTR path),BOOL;
	//
	// errors
	//
	declare GetError(),LPWSTR;
	declare GetErrorCode(),int;
	//
	// status
	//
	declare GetReadyState(),int; // 4: ready
	//
	// browsing
	//
	declare GetFirstNode(opt XML *node=0),BOOL;
	declare GetNextNode(XML *node),BOOL;
	declare GetChildNodeCount(),int;

	declare GetFirstAttribute(opt LPWSTR *ppName,VARIANT *value),BOOL;
	declare GetNextAttribute(LPWSTR *ppName,VARIANT *value),BOOL;
	declare GetAttributeCount(),int;
	//
	// modifications
	//
	declare SetVersion(LPWSTR version);
	declare AppendChildNode(LPWSTR name,opt LPWSTR text,XML *node),BOOL;
	declare AppendText(LPWSTR text),BOOL;
	declare AppendComment(LPWSTR text, XML *node),BOOL;
	declare AppendCDATA(LPWSTR text, XML *node),BOOL;
	declare SetAttribute(LPWSTR name, LPWSTR value),BOOL;
	declare SetAttributeEx(LPWSTR name, VARIANT *value),BOOL;
	declare RemoveAttribute(LPWSTR name),BOOL;
	declare RemoveNode(XML *node),BOOL;
	//
	// querying
	//
	declare GetAttribute(LPWSTR name,VARIANT *value),BOOL;
	declare HasChildNodes(),BOOL;
	declare GetName(),LPWSTR;
	declare GetText(),LPWSTR;
	declare GetValue(VARIANT *value),BOOL;
	//
	// callbacks
	//
	declare virtual OnReadyStateChanged();
	declare virtual OnDataAvailable();
	declare virtual OnTransformNode();
	//
	// private
	//
	declare Cleanup();
	declare IsIXMLDOMDocument(),BOOL;

	IXMLDOMDocument *m_doc[0];
	IXMLDOMNode     *m_node;

	IXMLDOMNodeList *m_childs;
	BSTR             m_name;
	BSTR             m_text;
	IXMLDOMNamedNodeMap *m_attrs; // GetFirstAttribute,GetNextAttribute

	CXMLDispatch m_onreadystatechange;
	CXMLDispatch m_ondataavailable;
	CXMLDispatch m_ontransformnode;
}
// size of class variables
const XMLVARSIZE = 0+4+4+4+4+4;

declare extern V_BSTR(VARIANT *pv, LPWSTR str);

/*
 * how to use optional parameter in GetFirstNode
 *
 * XML node;
 * x.GetFirstNode(NULL);
 * while (x.GetNextNode(&node))
 * {
 *    something();
 * }
 *
 * if (x.GetFirstNode(&node))
 * {
 *   do
 *   {
 *      something();
 *   }
 *   until !x.GetNextNode(&node);
 * }
*/

/*
 * how to use optional parameter in GetFirstAttribute
 *
 * WSTRING *pwszName;
 * VARIANT value;
 * x.GetFirstAttribute(NULL, NULL);
 * while (x.GetNextAttribute(&pwszName, &value))
 * {
 *    something();
 *    VariantClear(&value);
 * }
 *
 * if (x.GetFirstAttribute(&pwszName, &value))
 * {
 *   do
 *   {
 *      something();
 *      VariantClear(&value);
 *   }
 *   until !x.GetNextAttribute(&pwszName, &value);
 * }
*/
#endif
